<%@ LANGUAGE="VBSCRIPT" %>
<%
  '          IMAGE GALLERY    
  '
  ' ASP image directory browser, by David Park (dpark@sazan.net)
  ' release version 1.0, 2000-10-20
  '
  ' Instructions:
  '
  ' 1. Find or create a directory on your webserver that contains either 
  '    images or subdirectories with images
  ' 2. Copy this file to the chosen directory, and rename if desired
  ' 3. Change the first three constants below to match the choices above
  ' 4. (Optional) Change the navigation text and page title
  ' 5. Fire up a web browser, type in the URL to this file, and try it out
  '
  ' This browser supports GIF, JPG, and MPG files, though MPG support is 
  ' really up to the client.  It should be easy enough to add more formats 
  ' if desired.
  '
  ' The slideshow idea came from visiting the very cool Divine Comedy web site
  ' http://www.divinecomedy.org/

  Option Explicit
  Dim selectedDir, selectedImg, selectedNum
  Dim selectedDirURL, selectedImgURL
  Dim slideShow
  Dim fso, baseDir, subDirs, subFiles, fname
  Dim fileArr(), cnt

  ' SET CONSTANTS
  Const serverPath = "C:/Inetpub/wwwroot/images/"   ' local directory
  Const serverURL = "/images/"      ' URL path to directory above
  Const aspFile = "imagegal.asp"    ' name of this file

  Const pageTitle = "Image Gallery" ' title of page
  Const ssDelay = "10"              ' default slideshow delay (seconds)

  ' navigation link text
  Const linkHome = "Home"
  Const linkPrev = "Previous"
  Const linkUp = "Up"
  Const linkNext = "Next"
  Const linkSShow = "Slideshow"
  Const linkLabel = "Slideshow:"
  Const linkFast = "Faster"
  Const linkSlow = "Slower"
  Const linkStop = "Stop"
  Const linkBreak = "-"


  ' ------------ CODE BEGINS HERE ----------------

  ' QuickSort subroutine based on Java code by James Gosling
  ' http://www.cs.ubc.ca/spider/harrison/Java/sorting-demo.html
  ' http://www.cs.ubc.ca/spider/harrison/Java/QSortAlgorithm.java
  Sub QuickSort(ByRef a, lo0, hi0)
    Dim lo, hi, temp, pivot
    lo = lo0
    hi = hi0
 
    If (lo >= hi) Then
      Exit Sub
    ElseIf (lo = hi - 1) Then
      ' sort a two element list by swapping if necessary
      If (StrComp(a(lo),a(hi),vbTextCompare) > 0) Then
        temp = a(lo)
        a(lo) = a(hi)
        a(hi) = temp
      End If
      Exit Sub
    End If
    
    ' Pick a pivot and move it out of the way
    pivot = a((lo + hi) / 2)
    a((lo + hi) / 2) = a(hi)
    a(hi) = pivot

    While (lo < hi)
      ' Search forward from a[lo] until an element is found that
      ' is greater than the pivot or lo >= hi 
      While ((StrComp(a(lo),pivot,vbTextCompare) <= 0) And (lo < hi))
        lo = lo + 1
      Wend

      ' Search backward from a[hi] until element is found that
      ' is less than the pivot, or lo >= hi
      While ((StrComp(pivot,a(hi),vbTextCompare) <= 0) And (lo < hi))
        hi = hi - 1
      Wend

      ' Swap elements a[lo] and a[hi]
      If (lo < hi) Then
        temp = a(lo)
        a(lo) = a(hi)
        a(hi) = temp
      End If
    Wend

    ' Put the median in the "center" of the list
    a(hi0) = a(hi)
    a(hi) = pivot

    ' Recursive calls, elements a(lo0) to a(lo-1) are less than or
    ' equal to pivot, elements a(hi+1) to a(hi0) are greater than
    ' pivot.
    Call QuickSort(a, lo0, lo-1)
    Call QuickSort(a, hi+1, hi0)
  End Sub
  

  ' get posted vars (if any) from Request object
  selectedDir = Request.QueryString("dir")
  selectedDirURL = Replace(selectedDir," ","%20") 
  selectedImg = Request.QueryString("img")
  selectedImgURL = Replace(selectedImg," ","%20") 
  slideShow = Request.QueryString("ss")


  ' create file system object and get directory contents
  Set fso = CreateObject("Scripting.FileSystemObject")
  If (fso.FolderExists(serverPath & selectedDir)) Then
    ' TEST Response.Write "getting " & serverPath & selectedDir & "...<br><br>"
    Set baseDir = fso.GetFolder(serverPath & selectedDir)
  Else
    ' TEST Response.Write "getting root folder...<br><br>"
    Set baseDir = fso.GetFolder(serverPath)
  End If
  Set subDirs = baseDir.SubFolders
  Set subFiles = baseDir.Files

  ' create array of files in directory
  ReDim fileArr(subFiles.Count)
  cnt = 0
  For Each fname in subFiles
    If (InStr(LCase(fname.Name),".gif") or InStr(LCase(fname.Name),".jpg") or InStr(LCase(fname.Name),".mpg")) Then 
      fileArr(cnt) = fname.Name
      ' TEST Response.Write fname.Name & "<br>"
      cnt = cnt + 1
    End If
  Next
  ReDim Preserve fileArr(cnt)
  ' sort array alphabetically
  Call QuickSort(fileArr,0,cnt-1)

%><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
   "http://www.w3.org/TR/REC-html40/loose.dtd">
<html>
<head>
<%
   If (selectedImg <> "") Then
     Response.Write "  <title>" & pageTitle & ": " & selectedImg & "</title>"
   ElseIf (selectedDir <> "") Then
     Response.Write "  <title>" & pageTitle & ": " & selectedDir & "</title>"
   Else
     Response.Write "  <title>" & pageTitle & "</title>"
   End If
   If (slideShow <> "") Then
     ' find current image in array
     For cnt = 0 To UBound(fileArr)-1
       If (StrComp(fileArr(cnt),selectedImg,vbTextCompare) = 0) Then
         selectedNum = cnt
         Exit For
       End If    
     Next
     Response.Write "  <meta http-equiv='Refresh' content='" & slideShow & "; url="
     If (selectedNum < UBound(fileArr)-1) Then
       ' refresh URL points to next image file
       Response.Write aspFile & "?ss=" & slideShow & "&" 
       If (selectedDir <> "") Then
         Response.Write "dir=" & selectedDirURL & "&" 
       End If
       Response.Write "img=" & Replace(fileArr(selectedNum+1)," ","%20") & "'>"
     Else
       ' refresh URL points to parent directory, deactivates slideshow
       Response.Write aspFile
       If (InStrRev(LCase(selectedDirURL),"/")) Then
         Response.Write "?dir=" & Left(selectedDirURL,InStrRev(LCase(selectedDirURL),"/")-1) & "'>"
       Else
         Response.Write "'>"
       End If
     End If
   End If
 %>
</head>

<body bgcolor="#333333" text="#FFFFFF" link="#CC99CC" vlink="#996699"
   alink="#FFCCFF">
<%
  ' display stuff on the web page
  If (fso.FileExists(serverPath & selectedDir & "/" & selectedImg)) Then

    ' DISPLAY SINGLE IMAGE

    ' find current image in array
    For cnt = 0 To UBound(fileArr)-1
      If (StrComp(fileArr(cnt),selectedImg,vbTextCompare) = 0) Then
        selectedNum = cnt
        Exit For
      End If    
    Next
    Response.Write "<p>"
    ' surround image with link to next image in sequence
    If (selectedNum < UBound(fileArr)-1) Then
      Response.Write "<a href='" & aspFile & "?"
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & Replace(fileArr(selectedNum+1)," ","%20") & "'>"
    Else
      Response.Write "<a href='" & aspFile
      If (InStrRev(selectedDirURL,"/")) Then
        Response.Write "?dir=" & Left(selectedDirURL,InStrRev(LCase(selectedDirURL),"/")-1) & "'>"
      Else
        Response.Write "'>"
      End If
    End If
    ' display selected image
    If (InStr(1,selectedImg,".mpg",vbTextCompare)) Then
      Response.Write "<object data='" & serverURL & selectedDirURL & "/" & selectedImgURL & "'></object>"
    Else
      Response.Write "<img src='" & serverURL & selectedDirURL & "/" & selectedImgURL & "' alt='' border='0'>"
    End If
    Response.Write "</a>"
    Response.Write "</p><p>"

    ' display link to previous image
    If (selectedNum > 0) Then
      Response.Write "<a href='" & aspFile & "?"
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & Replace(fileArr(selectedNum-1)," ","%20") & "'>"
      Response.Write linkPrev & "</a> " & linkBreak & " "
    End If
    ' display link to parent directory
    Response.Write "<a href='" & aspFile
    If (InStrRev(LCase(selectedDirURL),"/")) Then
      Response.Write "?dir=" & Left(selectedDirURL,InStrRev(LCase(selectedDirURL),"/")-1) & "'>"
      Response.Write linkUp & "</a> "
    Else
      Response.Write "'>" & linkHome & "</a> "
    End If
    ' display link to next image
    If (selectedNum < UBound(fileArr)-1) Then
      Response.Write linkBreak & " <a href='" & aspFile & "?"
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & Replace(fileArr(selectedNum+1)," ","%20") & "'>"
      Response.Write linkNext & "</a> "
    End If
    ' display slideshow link
    If (slideShow = "") Then 
      Response.Write linkBreak & " <a href='" & aspFile & "?ss=" & ssDelay & "&" 
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & selectedImgURL & "'>" & linkSShow & "</a>"
    Else
      Response.Write linkBreak & " " & linkLabel & " <a href='" & aspFile 
      If (slideShow > 2) Then
        Response.Write "?ss=" & (slideShow - 2) & "&"
      Else
        Response.Write "?ss=2&"
      End If
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & selectedImgURL & "'>" & linkFast & "</a> "
      Response.Write linkBreak & " <a href='" & aspFile & "?ss=" & (slideShow + 2) & "&"
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & selectedImgURL & "'>" & linkSlow & "</a> "
      Response.Write linkBreak & " <a href='" & aspFile & "?" 
      If (selectedDir <> "") Then
        Response.Write "dir=" & selectedDirURL & "&" 
      End If
      Response.Write "img=" & selectedImgURL & "'>" & linkStop & "</a>"
    End If
  Else

    ' DISPLAY SUBDIRECTORY AND FILE LIST

    Response.Write "<h1>" & pageTitle & "</h1>"
    If (selectedImg = "") Then
      Response.Write "<h2>" & serverURL & selectedDir & "</h2><p>"
    Else
      Response.Write "<h2>" & serverURL & selectedDir & "/" & selectedImg & "</h2><p>"
    End If
    If (subDirs.Count > 0) Then
      Response.Write "<strong>Subfolders:</strong><br>"
      For Each fname in subDirs
        Response.Write "<a href='" & aspFile & "?dir=" 
        If (selectedDir <> "") Then
          Response.Write selectedDirURL & "/"
        End If
        Response.Write Replace(fname.name," ","%20") & "'>" & fname.name & "</a><br>"
      Next
      Response.Write "<br>"
    End If
    If (UBound(fileArr) > 0) Then
      Response.Write "<strong>Files:</strong><br>"
      For cnt = 0 to UBound(fileArr)-1
        Response.Write "<a href='" & aspFile & "?" 
        If (selectedDir <> "") Then
          Response.Write "dir=" & selectedDirURL & "&" 
        End If
        Response.Write "img=" & Replace(fileArr(cnt)," ","%20") & "'>" & fileArr(cnt) & "</a><br>"
      Next
    End If
    ' display link to parent directory
    If (selectedDir <> "") Then
      Response.Write "</p><p>"
      Response.Write "<a href='" & aspFile
      If (InStrRev(LCase(selectedDirURL),"/")) Then
        Response.Write "?dir=" & Left(selectedDirURL,InStrRev(LCase(selectedDirURL),"/")-1) & "'>"
        Response.Write linkUp & "</a>"
      Else
        Response.Write "'>" & linkHome & "</a>"
      End If
    End If
  End If
%>
</p>
</body>
</html>